{ $HDR$}
{**********************************************************************}
{ File archived using GP-Version                                       }
{ GP-Version is Copyright 1999 by Quality Software Components Ltd      }
{                                                                      }
{ For further information / comments, visit our WEB site at            }
{ http://www.qsc.co.uk                                                 }
{**********************************************************************}
{}
{ $Log:  E:\Archives\BUG July 2000\OpenGL\OpenGLText\OpenGLTextU.pas.z 
{
{   Rev 1.4    07/08/2000 07:37:17  Francois
{ fixed dialog
}
{
{   Rev 1.3    25/06/2000 20:23:02  Francois
{ WIP added POVRAY bitmap and "The-End" sequence 
{ where textured bitmap is enlarged gradually
}
{
{   Rev 1.2    24/06/2000 23:38:52  Francois
{ WIP fixed blinking cursor problem, added icon
}
{
{   Rev 1.1    24/06/2000 22:01:00  Francois
{ WIP got almost what I wanted
}
{
{   Rev 1.0    24/06/2000 14:17:54  Francois
{ main unit for OpenGL test program
}
{}
unit frmEasterEggU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AppEvnts,
  OpenGL12, ExtCtrls;

type
  TEasterEggState = set of (eesInitialised, essIntro, essCredits, essTheEnd);

  TfrmEasterEgg = class(TForm)
    memoEasterEgg: TMemo;
    ApplicationEvents1: TApplicationEvents;
    pnlImage: TPanel;
    Image1: TImage;
    pnlSpace: TPanel;
    btnDummy: TButton;
    pnl3D: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure memoEasterEggKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure memoEasterEggKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnDummyClick(Sender: TObject);
  private
    FAltDown: Boolean;
    FTypedText: String;
    FEasterEgg: Boolean;
    FEasterEggState: TEasterEggState;
    FRC: HGLRC;
    FTitleFontList, FFontList, FTextList, FMemoList, FTitleList: TGLuint;
    FEggBitmap: TGLuint;
    FTrajectory: Single;
    Fpnl3DCanvas: TControlCanvas;
    FOldMemoColor: TColor;
    FLastTime: DWORD;
    FFontHeight: Single;
    FFontWidth: Single;
    function CheckRes: Boolean;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure BuildText;
    procedure BuildTitle;
    procedure LoadBitmap;
  public
    procedure Setup;
  end;

var
  frmEasterEgg: TfrmEasterEgg;

implementation

uses
  RzCsIntf;

type
  TGlyphMetricsFloatArray = array[0..1024] of TGlyphMetricsFloat;
  PGlyphMetricsFloatArray = ^TGlyphMetricsFloatArray;

{$R *.DFM}

procedure TfrmEasterEgg.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  FAltDown := False;
  FTypedText := '';
  FEasterEgg := False;
  FEasterEggState := [];
  Caption := 'Easter Egg';
  Fpnl3DCanvas := nil;
  FLastTime := 0;
end;

procedure TfrmEasterEgg.FormDestroy(Sender: TObject);
begin
  if FEasterEgg then
  begin
    wglMakeCurrent(Fpnl3DCanvas.Handle, FRC);
    glDeleteLists(FFontList, 128);
    glDeleteTextures(1, @FEggBitmap);
    wglMakeCurrent(0, 0);
    wglDeleteContext(FRC);

    FEasterEgg := False;
    FEasterEggState := [];
    Caption := 'Easter Egg';
    if Assigned(Fpnl3DCanvas) then
    begin
      Fpnl3DCanvas.Free;
    end;
    pnl3D.SendToBack;
    memoEasterEgg.Font.Color := FOldMemoColor;
  end;
end;

procedure TfrmEasterEgg.FormResize(Sender: TObject);
begin
  if not FEasterEgg then
  begin
    Exit;
  end;
  if FRC <> 0 then
  begin
    ActivateRenderingContext(Fpnl3DCanvas.Handle, FRC);
    glViewport(0, 0, ClientWidth, ClientHeight);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity;
    if ClientHeight = 0 then ClientHeight := 1;
    gluPerspective(45, ClientWidth / ClientHeight, 1, 100);
    DeactivateRenderingContext;
  end;
end;

procedure TfrmEasterEgg.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  if not FEasterEgg then
  begin
    Exit;
  end;
  Message.Result := 1;
end;

procedure TfrmEasterEgg.memoEasterEggKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  ThisString: String;
begin
  if FEasterEgg then
  begin // Press any key will stop easter egg
    wglMakeCurrent(Fpnl3DCanvas.Handle, FRC);
    glDeleteLists(FFontList, 128);
    glDeleteTextures(1, @FEggBitmap);
    wglMakeCurrent(0, 0);
    wglDeleteContext(FRC);

    FEasterEgg := False;
    FEasterEggState := [];
    Caption := 'Easter Egg';
    if Assigned(Fpnl3DCanvas) then
    begin
      Fpnl3DCanvas.Free;
    end;
    pnl3D.SendToBack;
    memoEasterEgg.Font.Color := FOldMemoColor;
  end;
  if Key <> VK_MENU then
  begin
    if ssAlt in Shift then
    begin
      ThisString := Chr(Key);
      FTypedText := FTypedText + ThisString;
      if LowerCase(FTypedText) = 'easteregg' then
      begin
        FEasterEgg := True;
        FTypedText := '';
        FOldMemoColor := memoEasterEgg.Font.Color;
        memoEasterEgg.Font.Color := memoEasterEgg.Color;
      end;
    end;
  end;
end;

procedure TfrmEasterEgg.memoEasterEggKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_MENU then
  begin
    FTypedText := '';
  end;
end;

procedure TfrmEasterEgg.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
var
  ThisTime: DWORD;
begin
  if not FEasterEgg then
  begin
    Exit;
  end;

  // Kludge: need another control to get rid of blinking cursor in memo.
  btnDummy.SetFocus;
  
  ApplicationEvents1.CancelDispatch; 
  if essTheEnd in FEasterEggState then
  begin
    wglMakeCurrent(Fpnl3DCanvas.Handle, FRC);
    glDeleteLists(FFontList, 128);
    glDeleteTextures(1, @FEggBitmap);
    wglMakeCurrent(0, 0);
    wglDeleteContext(FRC);

    FEasterEgg := False;
    FEasterEggState := [];
    Caption := 'Easter Egg';
    if Assigned(Fpnl3DCanvas) then
    begin
      Fpnl3DCanvas.Free;
    end;
    pnl3D.SendToBack;
    memoEasterEgg.Font.Color := FOldMemoColor;
    Exit;
  end;
  if not (eesInitialised in FEasterEggState) then
  begin
    FEasterEggState := FEasterEggState + [eesInitialised];
    Caption := 'Easter Egg - Initialising';
    Setup;
    Repaint;
    Exit;
  end;
  ThisTime := GetTickCount;
  Done := False;
  if ThisTime - FLastTime < (1000 / 25) then
  begin
    Exit;
  end;

  if not (essIntro in FEasterEggState) then
  begin
    FTrajectory := FTrajectory + (FTrajectory / 30) + 0.05;
    if FTrajectory > FFontHeight * 25 then
    begin
      FEasterEggState := FEasterEggState + [essIntro];
      FTrajectory := 0.0;
    end;
    Caption := 'Easter Egg - Intro';
  end
  else if not (essCredits in FEasterEggState) then
  begin
    FTrajectory := FTrajectory + 0.05;
    if FTrajectory > FFontHeight * 20 then
    begin
      FEasterEggState := FEasterEggState + [essCredits];
      FTrajectory := 0.0;
    end;
    Caption := 'Easter Egg - Credits';
  end
  else if not (essTheEnd in FEasterEggState) then
  begin
    FTrajectory := FTrajectory + 0.05;
    if FTrajectory > FFontHeight * 0.8 then
    begin
      FEasterEggState := FEasterEggState + [essTheEnd];
      FTrajectory := 0.0;
    end;
    Caption := 'Easter Egg - The End';
  end;
  FLastTime := ThisTime;
  Repaint;
end;

const
  Light1: array[0..3] of Single = (-30, 30, 30, 1);
  Light2: array[0..3] of Single = (50, 100, 50, 1);

  Ambient: array[0..3] of Single = (0.9, 0.9, 0.1, 1);
  Diffuse1: array[0..3] of Single = (1, 1, 1, 1);
  Diffuse2: array[0..3] of Single = (0.9, 0.9, 0.0, 1);
  Diffuse3: array[0..3] of Single = (0.9, 0.9, 0.4, 1);
  Specular: array[0..3] of Single = (1, 1, 1, 1);

procedure TfrmEasterEgg.Setup;
var
  ThisAgmf: PGlyphMetricsFloat;
  ThisAgmfArray: PGlyphMetricsFloatArray;
  Loop: Integer;
  ThisMaxFontHeight, ThisMaxFontWidth: Single;
begin
  FTrajectory := 0.0;
  pnl3D.BringToFront;
  Fpnl3DCanvas := TControlCanvas.Create;
  Fpnl3DCanvas.Control := pnl3D;
  FRC := OpenGL12.CreateRenderingContext(Fpnl3DCanvas.Handle,
    [opDoubleBuffered], 32, 0, 0, 0, 0);
  wglMakeCurrent(Fpnl3DCanvas.Handle, FRC);

  glEnable(GL_DEPTH_TEST);
//  glEnable(GL_CULL_FACE);

  // Lichtquellen einrichten
  glEnable(GL_LIGHTING);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, Ord(GL_FALSE));

  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_POSITION, @Light1);
  glLightfv(GL_LIGHT0, GL_AMBIENT, @Ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @Diffuse1);
  glLightfv(GL_LIGHT0, GL_SPECULAR, @Specular);

  glEnable(GL_LIGHT1);
  glLightfv(GL_LIGHT1, GL_POSITION, @Light2);
  glLightfv(GL_LIGHT1, GL_AMBIENT, @Ambient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @Diffuse2);
  glLightfv(GL_LIGHT1, GL_SPECULAR, @Specular);

  // Setup font
  SelectObject(Fpnl3DCanvas.Handle, memoEasterEgg.Font.Handle);
  FFontList := glGenLists(128);
  ThisAgmfArray := AllocMem(128 * SizeOf(TGlyphMetricsFloat));
  try
    ThisAgmf := @(ThisAgmfArray[0]);
    wglUseFontOutlines(Fpnl3DCanvas.Handle, 0, 128, FFontList, 1, 0,
      WGL_FONT_POLYGONS, ThisAgmf);
    FFontHeight := 0.0;
    FFontWidth := 0.0;
    for Loop := 0 to 127 do
    begin
      ThisMaxFontHeight := ThisAgmfArray[Loop].gmfBlackBoxY;
      if ThisMaxFontHeight > FFontHeight then
      begin
        FFontHeight := ThisMaxFontHeight;
      end;
      ThisMaxFontWidth := ThisAgmfArray[Loop].gmfBlackBoxX;
      if ThisMaxFontWidth > FFontWidth then
      begin
        FFontWidth := ThisMaxFontWidth;
      end;
    end;
  finally
    FreeMem(ThisAgmfArray);
  end;
  FTitleFontList := glGenLists(128);
  ThisAgmfArray := AllocMem(128 * SizeOf(TGlyphMetricsFloat));
  try
    ThisAgmf := @(ThisAgmfArray[0]);
    glLineWidth(5);
    wglUseFontOutlines(Fpnl3DCanvas.Handle, 0, 128, FTitleFontList, 1, 0,
      WGL_FONT_LINES, ThisAgmf);
    FFontHeight := 0.0;
    FFontWidth := 0.0;
    for Loop := 0 to 127 do
    begin
      ThisMaxFontHeight := ThisAgmfArray[Loop].gmfBlackBoxY;
      if ThisMaxFontHeight > FFontHeight then
      begin
        FFontHeight := ThisMaxFontHeight;
      end;
      ThisMaxFontWidth := ThisAgmfArray[Loop].gmfBlackBoxX;
      if ThisMaxFontWidth > FFontWidth then
      begin
        FFontWidth := ThisMaxFontWidth;
      end;
    end;
  finally
    FreeMem(ThisAgmfArray);
  end;
  BuildText;
  BuildTitle;
  LoadBitmap;

  // Display Liste fr die Szene erstellen (hier ein Zylinder)
  glMateriali(GL_FRONT, GL_SHININESS, 128);
  glMaterialfv(GL_FRONT, GL_AMBIENT, @Ambient);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, @Diffuse3);
  glMaterialfv(GL_FRONT, GL_SPECULAR, @Specular);

  glViewport(0, 0, ClientWidth, ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  if ClientHeight = 0 then
     ClientHeight := 1;
  gluPerspective(45, ClientWidth / ClientHeight, 1, 100);

  if not CheckRes then
    Close;
  // background color
  glClearColor(0, 0, 0, 1);
end;

function TfrmEasterEgg.CheckRes: Boolean;
var
  Error: TGLEnum;
begin
  Error := glGetError;
  Result := Error = GL_NO_ERROR;
  if not Result then
  begin
//gluErrorString(Error);
  end;
end;

procedure TfrmEasterEgg.FormPaint(Sender: TObject);
const
  FogColor: array[0..3] of Single = (0, 0, 0, 0);
begin
  if not FEasterEgg then
  begin
    Exit;
  end;
  wglMakeCurrent(Fpnl3DCanvas.Handle, FRC);
  // clear "background" (color and depth buffer)
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  // Move object
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;

  // My text
//  glColor3ub(255, 0, 0);
  if not (essIntro in FEasterEggState) then
  begin
    glEnable(GL_FOG);
    glFogf(GL_FOG_MODE, GL_LINEAR);
    glFogfv(GL_FOG_COLOR, @FogColor);
    glFogf(GL_FOG_START, -5.0);
    glFogf(GL_FOG_END, 20.0);

    // viewer position and direction
    gluLookAt(0, 0, 12, 0, 0, 0, 0, 1, 0);

    glTranslatef(0, 0, 12 - FTrajectory);
    glCallList(FTitleList);
  end
  else if not (essCredits in FEasterEggState) then
  begin
    glEnable(GL_FOG);
    glFogf(GL_FOG_MODE, GL_LINEAR);
    glFogfv(GL_FOG_COLOR, @FogColor);
    glFogf(GL_FOG_START, 10.0);
    glFogf(GL_FOG_END, 20.0);

    // viewer position and direction
    gluLookAt(0, -10, 10, 0, 0, 0, 0, 1, 0);

    // Slide text
    glTranslatef(0, FTrajectory - 6, 0);
    glCallList(FTextList);
  end
  else if not (essTheEnd in FEasterEggState) then
  begin
    glDisable(GL_LIGHTING);
    glColor3ub(0, 0, 0);
    glClearColor(FTrajectory, FTrajectory, FTrajectory, 1);

    // viewer position and direction
    gluLookAt(0, 0, 12, 0, 0, 0, 0, 1, 0);

    glEnable(GL_TEXTURE_2D);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glBindTexture(GL_TEXTURE_2D, FEggBitmap);
    glBegin(GL_QUADS);
        glTexCoord2f(1, 1);

      glVertex3f(-7 - FTrajectory * 2.5, -2 - FTrajectory * 5, -4);

        glTexCoord2f(1, 0);

      glVertex3f(-7 - FTrajectory * 2.5, 2 + FTrajectory * 5, -4);

        glTexCoord2f(0, 0);

      glVertex3f(-5 + FTrajectory * 2.5, 2 + FTrajectory * 5, -4);

        glTexCoord2f(0, 1);

      glVertex3f(-5 + FTrajectory * 2.5, -2 - FTrajectory * 5, -4);
    glEnd;
    glDisable(GL_TEXTURE_2D);

    glTranslatef(6 - FTrajectory * 3, FTrajectory * 7, - FTrajectory * 5);
    glCallList(FMemoList);
  end;

  SwapBuffers(Fpnl3DCanvas.Handle);
  wglMakeCurrent(0, 0);
end;

procedure TfrmEasterEgg.BuildText;
var
  Loop, ThisLength, ThisMaxLength: Integer;
  ThisText: String;
  ThisPChar: PChar;
begin
  FTextList := glGenLists(1);
  glNewList(FTextList, GL_COMPILE);
  glPushMatrix;
    ThisMaxLength := 0;
    for Loop := 0 to memoEasterEgg.Lines.Count - 1 do
    begin
      ThisText := Trim(memoEasterEgg.Lines.Strings[Loop]);
      ThisLength := Length(ThisText);
      if ThisLength > ThisMaxLength then
      begin
        ThisMaxLength := ThisLength;
      end;
      ThisPChar := PChar(ThisText);
      glPushMatrix;
        glTranslatef(- ThisLength * FFontWidth / 2, 0, 0);
        glListBase(FFontList);
        glCallLists(ThisLength, GL_UNSIGNED_BYTE, ThisPChar);
      glPopMatrix;
      glTranslatef(0, - FFontHeight, 0);
    end;
  glPopMatrix;
  glEndList;

  FMemoList := glGenLists(1);
  glNewList(FMemoList, GL_COMPILE);
  glPushMatrix;
    glTranslatef(- ThisMaxLength * FFontWidth / 2, 0, 0);
    for Loop := 0 to memoEasterEgg.Lines.Count - 1 do
    begin
      ThisText := Trim(memoEasterEgg.Lines.Strings[Loop]);
      ThisLength := Length(ThisText);
      ThisPChar := PChar(ThisText);
      glPushMatrix;
        glListBase(FFontList);
        glCallLists(ThisLength, GL_UNSIGNED_BYTE, ThisPChar);
      glPopMatrix;
      glTranslatef(0, - FFontHeight, 0);
    end;
  glPopMatrix;
  glEndList;
end;

procedure TfrmEasterEgg.BuildTitle;
var
  ThisLength: Integer;
  ThisText: String;
  ThisPChar: PChar;
begin
  FTitleList := glGenLists(1);
  glNewList(FTitleList, GL_COMPILE);
  glPushMatrix;
    ThisText := Trim('Easter Egg');
    ThisLength := Length(ThisText);
    ThisPChar := PChar(ThisText);
    glTranslatef(- ThisLength * FFontWidth / 2, 0, 0);
    glListBase(FTitleFontList);
    glCallLists(ThisLength, GL_UNSIGNED_BYTE, ThisPChar);
  glPopMatrix;
  glEndList;
end;

procedure TfrmEasterEgg.btnDummyClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmEasterEgg.LoadBitmap;
var
  x,y, ArrayIndex: Integer;
  ThisBitMap: TBitMap;
  P: PByteArray;
  ThisOpenGlBitmap: PByteArray;
begin
  ThisBitMap := Image1.Picture.Bitmap;
  case ThisBitMap.PixelFormat of
  pf24bit:
  begin
    // OK
  end;
  else
  begin
// 'Unsupported bitmap pixel format'
    Exit;
  end;
  end;
  ThisOpenGlBitmap := AllocMem(ThisBitMap.height * ThisBitMap.width * 3);
  ArrayIndex := 0;
  for y := 0 to ThisBitMap.height -1 do
  begin
    P := ThisBitMap.ScanLine[y];
    for x := 0 to ThisBitMap.width -1 do
    begin
      ThisOpenGlBitmap[ArrayIndex + 0] := P[x * 3];
      ThisOpenGlBitmap[ArrayIndex + 1] := P[x * 3 + 1];
      ThisOpenGlBitmap[ArrayIndex + 2] := P[x * 3 + 2];
      ArrayIndex := ArrayIndex + 3;
    end;
  end;
  glEnable(GL_TEXTURE_2D);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glGenTextures(1, @FEggBitmap);
  glBindTexture(GL_TEXTURE_2D, FEggBitmap);
    glTexImage2D(GL_TEXTURE_2D, 0, 3,
      ThisBitMap.Width,
      ThisBitMap.Height,
      0, GL_BGR_EXT, GL_UNSIGNED_BYTE, ThisOpenGlBitmap);
    if not CheckRes then
    begin
      Close;
    end;  
  glDisable(GL_TEXTURE_2D);
end;

end.
